;; $Id: dbadmon.dsl 1.0 1997/12/30 17:48:14 nwalsh Exp $
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://www.berkshire.net/~norm/dsssl/
;;

;; ============================ ADMONITIONS =============================

(define ($admonition$)
  (let ((titles (select-elements (children (current-node)) "TITLE")))
    (make element gi: "BLOCKQUOTE"
	  attributes: (list
		       (list "CLASS" (gi)))
	  (if (not (node-list-empty? titles))
	      (make element gi: "P"
		    (make element gi: "B"
			  (with-mode title-mode
			    (process-first-descendant "TITLE"))))
	      (empty-sosofo))
	  (process-children))))

(define ($admonpara$)
  (let ((has-title (not (node-list-empty? 
			 (select-elements 
			  (children (parent (current-node))) "TITLE")))))
    (make sequence
      (if (and (not has-title) (= (child-number) 1))
	  (make element gi: "P"
		(make element gi: "B"
		      (literal
		       (cond
			((have-ancestor? "IMPORTANT") 
			 (string-append 
			  (gentext-element-name "IMPORTANT")
			  (gentext-label-title-sep "IMPORTANT")))
			((have-ancestor? "NOTE") 
			 (string-append
			  (gentext-element-name "NOTE")
			  (gentext-label-title-sep "NOTE")))
			((have-ancestor? "TIP") 
			 (string-append
			  (gentext-element-name "TIP")
			  (gentext-label-title-sep "TIP")))
			(else "")))))
	  (empty-sosofo))
      (make element gi: "P"
	    (process-children)))))

(element IMPORTANT ($admonition$))
(element (IMPORTANT TITLE) (empty-sosofo))
(element (IMPORTANT PARA) ($admonpara$))
(element NOTE ($admonition$))
(element (NOTE TITLE) (empty-sosofo))
(element (NOTE PARA) ($admonpara$))
(element TIP ($admonition$))
(element (TIP TITLE) (empty-sosofo))
(element (TIP PARA) ($admonpara$))

;; perils are given special treatment by generating a centered title
;;   and throwing a box around them
;;
(define ($peril$)
  (let ((titles (select-elements (children (current-node)) "TITLE")))
    (make element gi: "TABLE"
	  attributes: (list
		       (list "CLASS" (gi))
		       (list "BORDER" "1")
		       (list "WIDTH" "100%"))
	  (make element gi: "TR"
		(make element gi: "TD"
		      attributes: (list
				   (list "ALIGN" "CENTER"))
		      (make element gi: "B"
			    (cond
			     ((not (node-list-empty? titles))
			      (with-mode title-mode
				(process-first-descendant "TITLE")))
			     ((equal? (gi) "CAUTION") 
			      (literal (gentext-element-name "CAUTION")))
			     ((equal? (gi) "WARNING") 
			      (literal (gentext-element-name "WARNING")))
			     (else "")))))
	  (make element gi: "TR"
		(make element gi: "TD"
		      attributes: (list
				   (list "ALIGN" "LEFT"))
		      (process-children))))))

(element CAUTION ($peril$))
(element WARNING ($peril$))
(element (CAUTION TITLE) (empty-sosofo))
(element (WARNING TITLE) (empty-sosofo))
